package VKRep;

import java.io.*;

/**
 * <p>Title: </p>
 * <p>Description: Abstract class for all VK Reports containers.</p>
 * <p>Report containers allows to generate reports in any different
 * formats use only one program code and blanks in different formats.</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author Vlad Karpov
 * @version 1.0
 */

public abstract class TVKRptContainerAbstract implements Serializable, Runnable {

  /**
   *
   * <p>Title: class BOutStream </p>
   * <p>Description: This is inner class. It need for hold
   * intermediate streams.</p>
   * <p>Copyright: Copyright (c) 2003</p>
   * <p>Company: </p>
   * @author not attributable
   * @version 1.0
   */
  protected class BOutStream extends ByteArrayOutputStream {

    /**
     * Only constructor
     * @param size initial size of stream.
     */
    public BOutStream(int size){
      super(size);
    }

    /**
     * Return byte array of stream.
     * @return byte array of stream
     */
    public byte[] getBuffer(){
      return buf;
    }

  }

  /**
   * Only constructor.
   */
  public TVKRptContainerAbstract() {
  }

  /**
   * Abstract method. Should overload from descendant classes.
   * Start main process to generate of report.
   */
  public abstract void execute();

  /**
   * Implementing Runable interface.
   * Start main process to generate of report in separate thread.
   */
  public void run(){
    execute();
  }

}