package VKRep;

/**
 * <p>Title: </p>
 * <p>Description: class TVKRptContainerHorizontal allows to get
 * horizontal reports in different formats (use different formats in blanks)
 * use only one program code.</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author Vlad Karpov
 * @version 1.0
 */

public class TVKRptContainerHorizontal extends TVKRptContainerAbstract {

  /**
   * The object of main report generator.
   * It may be any TReportHorizontal descendant class object
   * (TXLS4ReportHorizontal ( :-) it only one horizontal
   * class now ), ....)
   */
  protected TReportHorizontal rptObj;

  /**
   * The Listener object. That is exactly "only one" code to
   * fill data of rptObj "input blank".
   */
  protected VKRepListener listener;

  /**
   * Only constructor.
   */
  public TVKRptContainerHorizontal() {
    rptObj = null;
    listener = null;
  }

  /**
   * The read property method of rptObj variable.
   * @return TReportHorizontal object is setting now.
   */
  public TReportHorizontal getRptObj() {
    return rptObj;
  }

  /**
   * The write property method of rptObj variable.
   * @param value TReportHorizontal object to setting now.
   */
  public void setRptObj(TReportHorizontal value){
    rptObj = value;
  }

  /**
   * The read property method of listener variable.
   * @return VKRepListener object is setting now.
   */
  public VKRepListener getListener() {
    return listener;
  }

  /**
   * The write property method of listener variable.
   * @param value VKRepListener object to setting now.
   */
  public void setListener(VKRepListener value) {
    listener = value;
  }

  /**
   * This method is start generate report.
   */
  public void execute(){
    if ( (rptObj != null) && (listener != null) ) {
      VKRepListener originalListener = rptObj.getListener();
      try {
        rptObj.setListener(listener);
        rptObj.execute();
      } finally {
        rptObj.setListener(originalListener);
      }
    }
  };

}